/*---------------------------------
            ByteCode.h
          Java Bytecodes
    Dan Ramage - March 16, 1997
---------------------------------*/

#define _bipush                (16)
//  Push next 1 byte signed int
#define _sipush                (17)
//  Push next 2 byte signed int
#define _ldc1                  (18)
//  Push constant pool val at offset 'next 1 byte'
#define _ldc2                  (19)
//  Same as _ldc1 but at 16bit offset  (2 bytes follow)
#define _ldc2w                 (20)
//  Same as _ldc2w but takes long at that pos
#define _aconst_null           (1)
//  Push null obj reference onto stack
#define _iconst_m1             (2)
//  Push integer const -1 onto stack
#define _iconst_0              (3)
#define _iconst_1              (4)
#define _iconst_2              (5)
#define _iconst_3              (6)
#define _iconst_4              (7)
#define _iconst_5              (8)
//  Push integer n from _iconst_<n> onto stack
#define _lconst_0              (9)
#define _lconst_1              (10)
//  Push long n from _lconst_<n> onto stack
#define _fconst_0              (11)
#define _fconst_1              (12)
#define _fconst_2              (13)
//  Push single precision floating point n from _fconst_<n> onto stack
#define _dconst_0              (14)
#define _dconst_1              (15)
//  Push double precision floating point n from _dconst_<n> onto stack
#define _iload                 (21)
//  Push int local variable at offset 'next byte' onto stack
#define _iload_0               (26)
#define _iload_1               (27)
#define _iload_2               (28)
#define _iload_3               (29)
//  Push int local variable at offset n from _iload_<n> onto stack
#define _lload                 (22)
//  Same as _iload but for long
#define _lload_0               (30)
#define _lload_1               (31)
#define _lload_2               (32)
#define _lload_3               (33)
//  Same as for _iload_<n> but for long
#define _fload                 (23)
#define _fload_0               (34)
#define _fload_1               (35)
#define _fload_2               (36)
#define _fload_3               (37)
//  You get the idea...  (floats)
#define _dload                 (24)
#define _dload_0               (38)
#define _dload_1               (39)
#define _dload_2               (40)
#define _dload_3               (41)
//  My fingers are getting bored...  (doubles)
#define _aload                 (25)
#define _aload_0               (42)
#define _aload_1               (43)
#define _aload_2               (44)
#define _aload_3               (45)
//  Starting to dose off...  (object refs)
#define _istore                (54)
//  Store integer off stack into local variable at offset 'next byte'
#define _istore_0              (59)
#define _istore_1              (60)
#define _istore_2              (61)
#define _istore_3              (62)
//  Store integer off stack to local variable <n>
#define _lstore                (55)
#define _lstore_0              (63)
#define _lstore_1              (64)
#define _lstore_2              (65)
#define _lstore_3              (66)
//  Same as for _istore variants but for long's
#define _fstore                (56)
#define _fstore_0              (67)
#define _fstore_1              (68)
#define _fstore_2              (69)
#define _fstore_3              (70)
//  Now floats
#define _dstore                (57)
#define _dstore_0              (71)
#define _dstore_1              (72)
#define _dstore_2              (73)
#define _dstore_3              (74)
//  Doubles
#define _astore                (58)
#define _astore_0              (75)
#define _astore_1              (76)
#define _astore_2              (77)
#define _astore_3              (78)
//  Obj refs
#define _iinc                  (132)
//  Increment integer local variable at 'next byte' by 'byte after that'
#define _wide                  (196)
//  Uses the 'next byte' to form a 16-bit local variable offset for use with
//  _iload, _istore, _aload, _astore, etc., comes before it.  The byte
//  This one is used to create the big offset along with the offset following
//  the next instruction
#define _newarray              (188)
//  Create a new array of size 'pop int off stack' and of type of 'next byte'
//  of the following allowed values.  Pushes a reference to the object
#define T_BOOLEAN              (4)
#define T_CHAR                 (5)
#define T_FLOAT                (6)
#define T_DOUBLE               (7)
#define T_BYTE                 (8)
#define T_SHORT                (9)
#define T_INT                  (10)
#define T_LONG                 (11)
//  Types of arrays for _newarray operand
#define _anewarray             (189)
//  Creates an array of size 'pop int off stack' for holding object (class)
//  references of type 'next two bytes used as index into constant pool'
#define _multianewarray        (197)
//  Too complex to explain here
#define _arraylength           (190)
//  Pops array handle off the stack and pushes its length
#define _iaload                (46)
//  Pops index into array (32 bit int), then array handle and pushes the
//  integer value at that position
#define _laload                (47)
//  Same as _iaload but for arrays of type long
#define _faload                (48)
//  Floating point
#define _daload                (49)
//  Double
#define _aaload                (50)
//  Object reference
#define _baload                (51)
//  boolean
#define _caload                (52)
//  char
#define _saload                (53)
//  short
#define _iastore               (79)
//  Pop int off stack, then index, then array ref and stores the int at index
//  in array
#define _lastore               (80)
//  Same as _iastore but for long
#define _fastore               (81)
//  float
#define _dastore               (82)
//  double
#define _aastore               (83)
//  object
#define _bastore               (84)
//  boolean
#define _castore               (85)
//  char
#define _sastore               (86)
//  short
#define _nop                   (0)
//  do nothing
#define _pop                   (87)
//  pop top off the stack
#define _pop2                  (88)
//  pop top 2 off the stack
#define _dup                   (89)
//  pop top stack and push it twice
#define _dup2                  (92)
//  pop top 2 off stack and push them twice
#define _dup_x1                (90)
//  same as _dup but instead of pushing it onto the top push it 2 blocks
//  below
#define _dup2_x1               (93)
//  same as _dup_x1 but for 2 blocks
#define _dup_x2                (91)
//  3 down
#define _dup2_x2               (94)
//  2 blocks, 3 down
#define _swap                  (95)
//  Swap top 2 stack ints
#define _iadd                  (96)
//  Pop top 2 int's, add, and push result
#define _ladd                  (97)
//  Pop top 2 long's, add, and push result
#define _fadd                  (98)
//  Floating point
#define _dadd                  (99)
//  Double
#define _isub                  (100)
//  Subtract top 2 ints and push result
#define _lsub                  (101)
#define _fsub                  (102)
#define _dsub                  (103)
#define _imul                  (104)
//  Multiply top 2 ints and push result
#define _lmul                  (105)
#define _fmul                  (106)
#define _dmul                  (107)
#define _idiv                  (108)
//  Divide top 2 ints and push result
#define _ldiv                  (109)
#define _fdiv                  (110)
#define _ddiv                  (111)
#define _irem                  (112)
//  Divide top 2 ints and push remainder
#define _lrem                  (113)
#define _frem                  (114)
#define _drem                  (115)
#define _ineg                  (116)
//  Negate integer and push result
#define _lneg                  (117)
#define _fneg                  (118)
#define _dneg                  (119)
#define _ishl                  (120)
//  Shift int left
#define _ishr                  (122)
//  Shift int right with sign extension
#define _iushr                 (124)
//  Shift int right without sign extension
#define _lshl                  (121)
//  Long shift left
#define _lshr                  (123)
//  Long shift right with sign extension
#define _lushr                 (125)
//  Long shift right without sign extension
#define _iand                  (126)
//  Int boolean and
#define _land                  (127)
//  Long boolean and
#define _ior                   (128)
//  Int boolean or
#define _lor                   (129)
//  Long boolean or
#define _ixor                  (130)
//  Int boolean xor
#define _lxor                  (131)
//  Long boolean xor
#define _i2l                   (133)
//  Int to long int
#define _i2f                   (134)
//  Int to float
#define _i2d                   (135)
//  Int to double
#define _l2i                   (136)
//  Long to int
#define _l2f                   (137)
//  Long to float
#define _l2d                   (138)
//  Long to double
#define _f2i                   (139)
//  Float to int
#define _f2l                   (140)
//  Float to long
#define _f2d                   (141)
//  Float to double
#define _d2i                   (142)
//  Double to int
#define _d2l                   (143)
//  Double to long
#define _d2f                   (144)
//  Double to float
#define _int2byte              (145)
//  Int to signed byte
#define _int2char              (146)
//  Int to char
#define _int2short             (147)
//  Int to short
#define _ifeq                  (153)
//  Branch if top int equal to zero
#define _ifnull                (198)
//  Branch if top obj ref null
#define _iflt                  (155)
//  Branch if top int less than 0
#define _ifle                  (158)
//  Branch if top int <= 0
#define _ifne                  (154)
//  Branch if top int != 0
#define _ifnonnull             (199)
//  Branch if top obj ref != 0
#define _ifgt                  (157)
//  Branch if top int > 0
#define _ifge                  (156)
//  Branch if top int >= 0
#define _if_icmpeq             (159)
//  Branch if top 2 ints ==
#define _if_icmpne             (160)
//  Branch if top 2 ints !=
#define _if_icmplt             (161)
//  Branch if 2nd to top int < top int
#define _if_icmpgt             (163)
//  Branch if 2nd to top int > top int
#define _if_icmple             (164)
//  Branch if 2nd to top int <= top int
#define _if_icmpge             (162)
//  Branch if 2nd to top int >= top int
#define _lcmp                  (148)
//  Compare long ints
#define _fcmpl                 (149)
//  Compare floats.  -1 for NaN
#define _fcmpg                 (150)
//  Compare floats.  1 for NaN
#define _dcmpl                 (151)
//  Same as _fcmpl but for double
#define _dcmpg                 (152)
//  Same as _fcmpg but for double
#define _if_acmpeq             (165)
//  Branch if object refs ==
#define _if_acmpne             (166)
//  Branch if object refs !=
#define _goto                  (167)
//  Branch always using a signed 16 bit offset
#define _goto_w                (200)
//  Branch always using a signed 32 bit offset
#define _jsr                   (168)
//  Goto subroutine;  pushes next inst. address before going
#define _jsr_w                 (201)
//  Wide variant of _jsr
#define _ret                   (169)
//  Return from subroutine using the local variable referenced by 'next byte'
//  as the return address
#define _ret_w                 (209)
//  Wide variant of _ret
#define _ireturn               (172)
//  Push int onto stack of callers stack, then return
#define _lreturn               (173)
//  Long variant of _ireturn
#define _freturn               (174)
//  Float
#define _dreturn               (175)
//  Double
#define _areturn               (176)
//  Object ref
#define _return                (177)
//  Return from a subroutine
#define _breakpoint            (202)
//  Give control to the breakpoint handler 
#define _tableswitch           (170)
#define _lookupswitch          (171)
#define _putfield              (181)
#define _getfield              (180)
#define _putstatic             (179)
#define _getstatic             (178)
//  Too complex to explain here
#define _invokevirtual         (182)
#define _invokenonvirtual      (183)
#define _invokestatic          (184)
#define _invokeinterface       (185)
#define _athrow                (191)
#define _new                   (187)
#define _checkcast             (192)
#define _instanceof            (193)
#define _monitorenter          (194)
#define _monitorexit           (195)
