PROC macro:

rem This macro to follow a link a file.
rem See {Downlink@downlink.wrd}

	local Text$(255)
	local file$(128)
	local Id$(255)
	local App$(255)
	local pid%
	local a%, b%, c%

	file$="address.dbf"

	pid%=Actpid%:

	Useapp:("active")

	rem if we don't support dialogs
	if NOT info:(4)
		return
	endif
	
	rem Read text at cursor
	text$=GetTxt$:("")

	rem Test if delimiters
	a%=loc(text$,"{")
	b%=loc(text$,"}")
	if a%<>0 and b% <>0
		rem if exists -> read it
		c%=loc(text$,"@")
		if c% <> 0
			file$=mid$(text$,c%+1,b%-c%-1)
			id$=mid$(text$, a%+1, c%-a%-1)
		else
			id$=mid$(text$, a%+1, b%-a%-1)
		endif
	else
		id$=text$
		dInit:( "Search in Address" )
		dEdit:( addr( id$ ), "Find what:", 13 )

		rem if cancel
		if Dialog: = 0
			rem restore ourselves and give up
			UsePid:(pid%)
			return
		endif
	endif

	rem Find the application
	if file$ <> ""
		app$ = App$:(file$)
	else
		app$ = Pid2App$:( pid% )
	endif

	rem Run app with this file
	RunAppC:( app$, file$)
	
	rem Find in this app
	if id$<>""
		FindText:(app$, id$)
	endif
	
	ToFront:
ENDP 


PROC App$:(file$)
rem returns the name of an app to edit file

	local ext$(3)

	ext$=upper$( right$(file$ , 3) )

	if ext$="WRD"
		return "word"
	elseif ext$="SPR" 
		return "sheet"
	elseif ext$="DBF" 
		return "data"
	endif

	return ""
 
ENDP


PROC FindText:(app$, text$)
rem Issue commands to find text$ in application

	if app$="word"
		rem Go to beginning and find
		Sendkey:(260,12,1)    :rem Psion-Ctrl-Up
		SendKey:( psion% + %f, 0, 0 ) :rem Psion-f once
		SendText:( text$ )
		Sendkey:( enter%, 0, 0)
	elseif app$="data"
		rem Go to record 1 and find
		SendKey:(618,8,1) rem Psion-J
		SendKey:(49,0,1) rem 1
		SendKey:(13,0,1) rem Enter
		SendText:(text$) 
		SendKey:(13,0,1) rem Enter
	elseif app$="sheet"
		rem Go to beginning and find
		Sendkey:(260,12,1)    :rem Psion-Ctrl-Up
		SendKey:( psion% + %f, 0, 0 ) :rem Psion-f once
		SendText:( text$ )
		Sendkey:( enter%, 0, 0)
	else
		rem Go to beginning and find
		Sendkey:(260,12,1)    :rem Psion-Ctrl-Up
		SendKey:( psion% + %f, 0, 0 ) :rem Psion-f once
		SendText:( text$ )
		Sendkey:( enter%, 0, 0)
	endif
ENDP


PROC MakeSrv:
rem Make the current app the bring server

local pid%
	pid% = CurrPid%:

	ToMacro:
	cls
	Tofront:
	UsePid:( pid% ) 
	Tofront:
ENDP

PROC GetTxt$:(app$)
rem Get the entry in the current app.
rem In time this may use different methods depending
rem on the current application. 

local sel$(255)

	rem if we are not already the bring server
	if (CurrPid%: <> SrvPid%:) 
		rem try to make us
		MakeSrv:
	endif

	rem if we have a selection
	if (CurrPid%: = SrvPid%:) AND (TestSrv%: = 0)
		rem get it
		sel$ = GetText$:
	endif
	if sel$ = ""
		rem make a selection and try again
		rem if we support macro
		if info:(4)
			Sendkey:(263,14,1)
			MakeSrv:
		endif
		if (CurrPid%: = SrvPid%:) AND (TestSrv%: = 0)
			rem get it
			sel$ = GetText$:
		else
			sel$ = ""
		endif
	endif

	rem if we have still failed return nothing
	if sel$ = ""
		return ""
	endif

	rem clear any outside spaces
	if right$(sel$, 1) = " "
		sel$ = left$(sel$, len(sel$)-1)
	endif
	if left$(sel$, 1) = " "
		sel$ = right$( sel$, len(sel$)-1 )
	endif
	
	return sel$
	
ENDP


PROC TestSrv%:
rem Returns 0 if there is data available to bring

local wsrv$(15), in%(6), fmt&, pid%, pfmt%

	wsrv$ = "SYS$WSRV.*" + chr$(0)
	in%(1) = $100
	in%(2) = uadd( addr( wsrv$ ), 1 )
	if os( $88, addr( in%(1) ) ) and 1
		return ( in%(1) and $ff ) - $100
	else
		pid% = in%(1)
	endif

	pfmt% = addr( fmt& )
	if call( $683, pid%, 4, 0, addr( pfmt% ),0 ) <= 0
		return -33 rem Bring server not found
	endif

	if ( fmt& and $16 ) = 0
		return -36 rem Bring server has no data available
	endif

ENDP

PROC Debug:( a$ )
	dInit:( a$ )
	Dialog:
ENDP


