/*
    FILETAGS.C

Written by DavidW
Started on 31/7/94

*/

#include <p_std.h>
#include <p_object.h>
#include <hwif.h>
#include <hwim.h>

#include <chlist.g>
#include <files.g>
#include <ftags.g>
#include "ftags.rsg"

LOCAL_D VOID *ViewTags;
LOCAL_D UWORD EnterPressed;
LOCAL_D TEXT ViewName[P_FNAMESIZE];
LOCAL_D TEXT *pDialogText;


LOCAL_C VOID doDial(INT classno,INT resid)
    {
    hOODialog(p_getlibh(CAT_FTAGS_FTAGS),classno,resid,NULL);
    }

LOCAL_C VOID TellViewed(TEXT *pText)
    {
    pDialogText=pText;
    doDial(C_INFO_DL,DL_INFO);
    }

LOCAL_C INT ConfirmDiscardTags(VOID)
    {
    UWORD rbuf;

    hOODialog(p_getlibh(CAT_FTAGS_HWIM),C_DLGBOX,DL_DISCARD,&rbuf);
    return(rbuf==1);
    }

LOCAL_C VOID MainLoop(VOID)
    {
    FOREVER
        {
        EnterPressed=FALSE;
        doDial(C_CHOOSE_DL,DL_CHOOSE);
        if (!EnterPressed)
            TellViewed("None - dialog cancelled");
        else if (!ViewTags)
            TellViewed(&ViewName[0]);
        else
            doDial(C_VIEW_DL,DL_VIEW);
        if (ViewTags && ConfirmDiscardTags())
            {
            p_send2(ViewTags,O_DESTROY);
            ViewTags=NULL;
            }
        }
    }

LOCAL_C VOID SpecificInit(VOID)
    {
    hInitAppRcb();
    hCrackCommandLine();
    }

GLDEF_C VOID main(VOID)
    {
    uCommonInit();
    SpecificInit();
    MainLoop();
    }

#pragma METHOD_CALL

METHOD VOID choose_dl_dl_dyn_init(PR_DLGBOX *self)
    {
    VOID *fnselwn;

    fnselwn=(VOID *)p_send3(self,O_DL_INDEX_TO_HANDLE,1);
    if (ViewTags)
        p_send5(fnselwn,O_FNS_INSERT_TAGS,ViewTags,TRUE,&ViewName[0]);
    else
        hDlgSet(1,&ViewName[0]);
    }

METHOD INT choose_dl_dl_key(PR_DLGBOX *self)
    {
    VOID *fnselwn;
    VOID *newTags;

    fnselwn=(VOID *)p_send3(self,O_DL_INDEX_TO_HANDLE,1);
    newTags=(VOID *)p_send2(fnselwn,O_FNS_EXTRACT_TAGS);
    if (!newTags && ViewTags)
        p_send2(ViewTags,O_DESTROY);
    ViewTags=newTags;
    hDlgSense(1,&ViewName[0]);
    EnterPressed=TRUE;
    return(WN_KEY_CHANGED);
    }

METHOD VOID view_dl_dl_dyn_init(PR_VIEW_DL *self)
    {
    SE_CHLIST set;

    set.data=ViewTags;
    set.set_flags=SE_CHLIST_RETAIN|SE_CHLIST_DATA;
    hDlgSet(1,&set);
    self->view_dl.ntags=p_send2(ViewTags,O_VA_COUNT)-1;
    }

METHOD VOID view_dl_dl_set_size(PR_VIEW_DL *self)
    {
    p_supersend2(self,O_DL_SET_SIZE);
    p_send2(self,O_DL_CHANGED);     /* after size calculated */
    }

METHOD VOID view_dl_dl_changed(PR_VIEW_DL *self)
    {
    UWORD rid;
    UWORD nsel;
    TEXT buf[20];

    nsel=hDlgSenseChlist(1);
    rid=(nsel? self->view_dl.ntags>1? STR_VIEW_FILES_CHOSEN:
                                STR_VIEW_FILE_CHOSEN: STR_VIEW_PATH);
    if (self->view_dl.promptRid==rid)
        return;
    self->view_dl.promptRid=rid;
    hLoadResBuf(rid,&buf[0]);
    hDlgSetPrompt(1,&buf[0]);
    }

METHOD VOID info_dl_dl_dyn_init(VOID)
    {
    hDlgSetText(1,pDialogText);
    }
