// HWIMCCO.C
// Main module for HWIMCC - Custom Dialog Control Demo

#include <hwim.h>
#include <hwimcc.g>
#include <hwimcc.rg>
#include <hwimcc.rsg>
#include <epoc.h>

#pragma save, METHOD_CALL

// Create all custom controls in the class par->class in
// category CAT_HWIMCC_HWIMCC instead of in HWIM category
METHOD VOID *dlg_search_dl_item_new(PR_DLGBOX *self, AD_DLGBOX *par) {
    return(f_new(CAT_HWIMCC_HWIMCC, par->class)) ;
}

// Only accepts the string "TEST"
METHOD INT myedwin_lg_self_check(PR_MYEDWIN *self, INT item, INT can_defer) {
    SE_EDWIN    sense ;
    INT         fOK ;

    p_send3(self, O_WN_SENSE, &sense) ;
    fOK = p_scmp(sense.buf, "TEST") == 0 ;
    if ( !fOK ) {
        hInfoPrint(RS_TESTONLY) ;
    }
    return(fOK ? LG_CHECK_OK_CHANGED : LG_CHECK_FAILED_CHANGED) ;
}

// Converts all keys to upper case
METHOD INT myedwin_wn_key(PR_MYEDWIN *self, UINT keycode, UINT modifiers) {
    return(p_supersend4(self, O_WN_KEY, p_toupper(keycode), modifiers)) ;
}

#pragma restore

GLDEF_C INT LaunchDialog(INT class, INT resid, VOID *rbuf) {
    DL_DATA     dld ;

    dld.id = resid ;
    dld.rbuf = rbuf ;
    dld.pdlg = NULL ;
    return(hLaunchDial(CAT_HWIMCC_HWIMCC, class, &dld)) ;
}

GLDEF_C VOID main(VOID) {
    IN_HWIMMAN          app ;
    IN_WSERV            wserv ;

    p_linklib(0) ;
    app.flags = FLG_APPMAN_RSCFILE |
                    FLG_APPMAN_SRSCFILE |
                    FLG_APPMAN_CLEAN |
                    FLG_APPMAN_FULLSCREEN |
                    FLG_APPMAN_ONLYONE ;
    app.wserv_cat = p_getlibh(CAT_HWIMCC_HWIMCC) ;
    app.wserv_class = C_MYWS ;
    wserv.com_cat = p_getlibh(CAT_HWIMCC_HWIMCC) ;
    wserv.com_class = C_MYCM ;

    p_send4(p_new(CAT_HWIMCC_HWIM, C_HWIMMAN), O_AM_INIT, &app, &wserv) ;
}

GLREF_D WSERV_SPEC *    wserv_channel ;

#pragma save, METHOD_CALL

METHOD VOID myws_ws_dyn_init(PR_MYWS *self) {
    W_WINDATA   wd ;

    self->wserv.cli = f_new(CAT_HWIMCC_HWIM, C_BWIN) ;
    wd.extent.tl.x = 0 ;
    wd.extent.tl.y = 0 ;
    wd.extent.width = wserv_channel->conn.info.pixels.x ;
    wd.extent.height = wserv_channel->conn.info.pixels.y ;
    p_send5(self->wserv.cli, O_WN_CONNECT, NULL, W_WIN_EXTENT, &wd) ;
    p_send3(self->wserv.cli, O_WN_VISIBLE, WV_INITVIS) ;
    p_send3(self->wserv.cli, O_WN_EMPHASISE, TRUE) ;
}

METHOD VOID mycm_mycm_search(PR_MYCM *self) {
    LaunchDialog(C_DLG_SEARCH, CUSTOM_DIALOG, NULL) ;
}
