/* --------------------------------
              Jro.c
    Java Runtime Object DYL code
          Subclasses AIDLE
    Dan Ramage - March 15, 1997
---------------------------------*/

/*  This object will only be created by the garbage collector and should
not be accessed directly by any other object!  */

#include <java.g>

#pragma save,call(reg_param =>(si),reg_saved =>(ax,bx,cx,dx,si,di,EPOC_SAVE))
extern void near enter_thread(UWORD stack);
#pragma restore

#pragma METHOD_CALL

METHOD VOID jro_destroy(PR_JRO *self)
    {
    p_free(self->jro.stack_java);
    /*  Kill the java stack  */

    p_supersend2(self, O_DESTROY);
    /*  Now we kill ourselves  */
    }

METHOD VOID jro_ao_init(PR_JRO *self)
/*  This method is called on initialization of
the JRO  (Java Runtime Object).  The information about
where to first execute the code, etc., will be passed
in a later version of this code.  */
    {
    self->jro.stack_java = p_alloc(JRO_STACK_SIZE);
/*  We initialise the java stack  */
    self->jro.optop = self->jro.stack_java + JRO_STACK_SIZE;
/*  Next we set optop to the top of the cell we just allocated  */
    }

METHOD VOID jro_ao_run(PR_JRO *self)
/*  This message is automatically called by the owning
JRO giving our object a chance to run.  The code in this
function should be considered the 'meat' of a loop.
The difference between this loop and a normal one is
that we do not have the do() or while() statements,
but leave loop control up to the JRO object.  */
    {
    enter_thread((UWORD)self->jro.optop);
/*  Here we continue execution of our thread  */
    }

METHOD VOID jro_jro_send_mess(PR_JRO *self, TEXT *method)
    {
    }
