;                Jrorn.asm
;  Native Code Assebler Entry and Exit Routines
;       Dan Ramage - March 15, 1997

[GLOBAL _enter_thread]
[GLOBAL _exit_test]

[SECTION _TEXT CLASS=CODE]
_enter_thread
; Initialise the stack pointers
; Remember: SI = java stack operand pointer (optop)
    mov [sp_java],si
    mov [sp_sys],sp
; Initialise counter to another 5 INVOKEs
    mov [counter],word 5
; Return to where we left off
    mov sp,[sp_java]
    ret

_exit_test
; Check to see if we have used up our INVOKEs
    dec word [counter]
    jz .exit_thread
    ret
.exit_thread
; Return to normal system stack and return
    mov sp,sp_sys
    ret

; This is the form which the native compiled java bytecodes will take:
;
; <code that doesn't call a java run-time library routine here>
; call _exit_test
; _INVOKE_METHOD
;
; This allows for our compiler to be very simple.  All it needs to do is
; to compile the java bytecodes to native code, then whenever it needs to
; do call a java run-time library routine, it inserts a CALL _exit_test
; instruction first.  This will execute _exit_test and end up returning
; after n mehtod routines (5 in the above example).

[SECTION _DATA CLASS=DATA]
sp_java dw
sp_sys dw
counter dw
