/*---------------------------------
            Native16.h
     Native 8086 16-bit codes
  Dan Ramage - February 25, 1997
---------------------------------*/

#define ADD_AX_AX                (0x01C0)
#define ADD_AX_BX                (0x01D8)
#define ADD_AX_CX                (0x01C8)
#define ADD_AX_DX                (0x01D0)
#define ADD_AX_FF(x)             (0x050000 | x)
#define AND_AX_BX                (0x21D8)
#define AND_AX_FF(x)             (0X250000 | x)
#define CALL_AX                  (0xFFD0)
#define CALL_BX                  (0xFFD3)
#define CALL_CX                  (0xFFD1)
#define CALL_DX                  (0xFFD2)
#define CBW                      (0x98)
#define CLC                      (0xF8)
#define CLD                      (0xFC)
#define CLI                      (0xFA)
#define CMC                      (0xF5)
#define CMP_AX_BX                (0x39D8)
#define CS:                      (0x2E)
#define CWD                      (0x99)
#define DEC_AX                   (0x48)
#define DEC_BX                   (0x4B)
#define DEC_CX                   (0x49)
#define DEC_DX                   (0x4A)
#define DIV_AX                   (0xF7F0)
#define DIV_BX                   (0xF7F3)
#define DIV_CX                   (0xF7F1)
#define DIV_DX                   (0xF7F2)
#define DS:                      (0x3E)
#define ES:                      (0x26)
#define INC_AX                   (0x40)
#define INC_BX                   (0x43)
#define INC_CX                   (0x41)
#define INC_DX                   (0x42)
#define INT_FF(x)                (0xCD00 | x)
#define JA_FF(x)                 (0x7700 | x)
#define JB_FF(x)                 (0x7200 | x)
#define JBE_FF(x)                (0x7600 | x)
#define JG_FF(x)                 (0x7F00 | x)
#define JGE_FF(x)                (0x7D00 | x)
#define JL_FF(x)                 (0x7C00 | x)
#define JLE_FF(x)                (0x7E00 | x)
#define JMP_AX                   (0xFFE0)
#define JMP_BX                   (0xFFE3)
#define JMP_CX                   (0xFFE1)
#define JMP_DX                   (0xFFE2)
#define JNB_FF(x)                (0x7300 | x)
#define JNC_FF(x)                (0x7300 | x)
#define JNO_FF(x)                (0x7100 | x)
#define JNS_FF(x)                (0x7900 | x)
#define JNZ_FF(x)                (0x7500 | x)
#define JO_FF(x)                 (0x7000 | x)
#define JPE_FF(x)                (0x7A00 | x)
#define JPO_FF(x)                (0x7B00 | x)
#define JS_FF(x)                 (0x7800 | x)
#define JZ_FF(x)                 (0x7400 | x)
#define MOV_AX_BX                (0x89D8)
#define MOV_AX_CX                (0x89C8)
#define MOV_AX_DX                (0x89D0)
#define MOV_AX_SI                (0x89F0)
#define MOV_AX_DI                (0x89F8)
#define MOV_AX_CS                (0x8CC8)
#define MOV_AX_DS                (0x8CD8)
#define MOV_AX_ES                (0x8CC0)
#define MOV_AX_SS                (0x8CD0)
#define MOV_AX_SP                (0x89E0)
#define MOV_AX_FF(x)             (0xB80000 | x)
#define MOV_AX_[FF](x)           (0xA10000 | x)
#define MOV_BX_AX                (0x89C3)
#define MOV_BX_CX                (0x89CB)
#define MOV_BX_DX                (0x89D3)
#define MOV_BX_CS                (0x8CCB)
#define MOV_BX_DS                (0x8CDB)
#define MOV_BX_ES                (0x8CC3)
#define MOV_BX_SS                (0x8CD3)
#define MOV_BX_FF(x)             (0xBB0000 | x)
#define MOV_CX_AX                (0x89C1)
#define MOV_CX_BX                (0x89D9)
#define MOV_CX_DX                (0x89D1)
#define MOV_CX_CS                (0x8CC9)
#define MOV_CX_DS                (0x8CD9)
#define MOV_CX_ES                (0x8CC1)
#define MOV_CX_SS                (0x8CD1)
#define MOV_CX_FF(x)             (0xB90000 | x)
#define MOV_DX_AX                (0x89C2)
#define MOV_DX_BX                (0x89DA)
#define MOV_DX_CX                (0x89CA)
#define MOV_DX_CS                (0x8CCA)
#define MOV_DX_DS                (0x8CDA)
#define MOV_DX_ES                (0x8CC2)
#define MOV_DX_SS                (0x8CD2)
#define MOV_DX_FF(x)             (0xBA0000 | x)
#define MOV_SI_AX                (0x89C6)
#define MOV_SI_FF(x)             (0xBE0000 | x)
#define MOV_DI_AX                (0x89C7)
#define MOV_DI_FF(x)             (0xBF0000 | x)
#define MOV_CS_AX                (0x8EC8)
#define MOV_CS_BX                (0x8ECB)
#define MOV_CS_CX                (0x8EC9)
#define MOV_CS_DX                (0x8ECA)
#define MOV_DS_AX                (0x8ED8)
#define MOV_DS_BX                (0x8EDB)
#define MOV_DS_CX                (0x8ED9)
#define MOV_DS_DX                (0x8EDA)
#define MOV_ES_AX                (0x8EC0)
#define MOV_ES_BX                (0x8EC3)
#define MOV_ES_CX                (0x8EC1)
#define MOV_ES_DX                (0x8EC2)
#define MOV_SS_AX                (0x8ED0)
#define MOV_SS_BX                (0x8ED3)
#define MOV_SS_CX                (0x8ED1)
#define MOV_SS_DX                (0x8ED2)
#define MOV_oFF_AX(x)           (0xA30000 | x)
#define MOV_oFF_BX(x)           (0x891E0000 | x)
#define MOV_oFF_CX(x)           (0x890E0000 | x)
#define MOV_oFF_DX(x)           (0x89160000 | x)
#define MOV_oFF_SI(x)           (0x89360000 | x)
#define MOV_oFF_DI(x)           (0x893E0000 | x)
#define MOV_oFF_CS(x)           (0x8C0E0000 | x)
#define MOV_oFF_DS(x)           (0x8C1E0000 | x)
#define MOV_oFF_ES(x)           (0x8C060000 | x)
#define MOV_oFF_SS(x)           (0x8C160000 | x)
#define MOV_oFF_BP(x)           (0x892E0000 | x)
#define MOV_oFF_IP(x)           (0x89260000 | x)
#define MUL_AX                   (0xF7E0)
#define MUL_BX                   (0xF7E3)
#define MUL_CX                   (0xF7E1)
#define MUL_DX                   (0xF7E2)
#define NEG_AX                   (0xF7D8)
#define NEG_BX                   (0xF7DB)
#define NEG_CX                   (0xF7D9)
#define NEG_DX                   (0xF7DA)
#define NOP                      (0x90)
#define NOT_AX                   (0xF7D0)
#define NOT_BX                   (0xF7D3)
#define NOT_CX                   (0xF7D1)
#define NOT_DX                   (0xF7D2)
#define OR_AX_BX                 (0x09D8)
#define POP_AX                   (0x58)
#define POP_BX                   (0x5B)
#define POP_CX                   (0x59)
#define POP_DX                   (0x5A)
#define POP_CS                   (0x0F)
#define POP_DS                   (0x1F)
#define POP_ES                   (0x07)
#define POP_SS                   (0x17)
#define PUSH_AX                  (0x50)
#define PUSH_BX                  (0x53)
#define PUSH_CX                  (0x51)
#define PUSH_DX                  (0x52)
#define PUSH_CS                  (0x0E)
#define PUSH_DS                  (0x1E)
#define PUSH_ES                  (0x06)
#define PUSH_SS                  (0x16)
#define PUSHF                    (0x9C)
#define REP                      (0xF3)
#define REPE                     (0xF3)
#define REPNE                    (0xF2)
#define REPNZ                    (0xF2)
#define REPZ                     (0xF3)
#define RET                      (0xC3)
#define RETF                     (0xCB)
#define SS:                      (0x36)
#define STC                      (0xF9)
#define STD                      (0xFD)
#define STI                      (0xFB)
#define SUB_SI_DX                (0x2BF2)
#define TEST_AX_BX               (0x85D8)
#define TEST_AX_CX               (0x85C8)
#define TEST_AX_DX               (0x85D0)
#define WAIT                     (0x9B)
#define XCHG_AX_BX               (0x93)
#define XLAT                     (0xD7)
#define XOR_AX_AX                (0x31C0)
#define XOR_AX_BX                (0x31D8)
#define XOR_AX_FF(x)             (0x350000 | x)
